////////////////////////////////////////////////////////////////
//Aufgabe 5a aus Kapitel Bibliotheken
//Beispiel für toxiclips Geometrie- und Physikbibliothek
//Mehrfachpendel mit äußerer Kraft (zeichnet Verlaufsspuren)
//Kraft kann durch mousePresse (bzw. mouseDragge) gesetzt werden
///////////////////////////////////////////////////////////////
import toxi.physics2d.*;
import toxi.physics2d.behaviors.*;
import toxi.geom.*;


VerletPhysics2D physics;
AttractionBehavior2D mouseAttractor;
AttractionBehavior2D zufallAttractor;
int i =0;
float laenge  = 50;//Federlänge
int anzahlMassen =8;
float fHaerte = 1;//Federhärte
Vec2D mausPos, zufallPos;
boolean kraftZeichnen = false;
VerletSpring2D [] feder = new VerletSpring2D[anzahlMassen];
Masse [] m = new Masse[anzahlMassen+1] ;
color farbe;//Farbe der Massen

void setup(){
  size(1000, 1000);
  background(255);
  stroke(70,100);
  strokeWeight(1);
  m[0] = new Masse(new Vec2D(width/2, height/2),0,10,color(0));
  m[0].lock();//Aufhängung: m[0] bewegt sich nicht
  for(int i =1;i<=anzahlMassen;i++){
    farbe = color(random(255),random(255),random(255));
    m[i]= new Masse(new Vec2D(width/2+random(3),height/2-i*laenge),1,3,farbe);
  }
  //Federstücke initialisieren
  for(int i =0;i<anzahlMassen;i++){
    feder[i]= new VerletSpring2D(m[i], m[i+1], laenge, fHaerte);
  }
  //Physik-Bibliothek initialisieren
  physics = new VerletPhysics2D();
  physics.setWorldBounds(new Rect(0, 0, width, height));
  
  //Gravitationskraft F = (0,0.1) zeigt senkrecht nach unten
  physics.addBehavior(new GravityBehavior2D(new Vec2D(0, 0.1)));//(0,0.1)
  
  //Massenpunkte und Federn in die Welt bringen
  for(int i =0;i<anzahlMassen+1;i++){
    physics.addParticle(m[i]);
  }
  for(int i =0;i<anzahlMassen;i++){
     physics.addSpring(feder[i]);
  }
  
}

void draw(){
  //Positionen aller Massenpunkte und Federn im Laufe der Zeit
  physics.update();
 
  stroke(70,100);
  strokeWeight(1);
  for(int i =0;i<anzahlMassen;i++){
     line(m[i].x,m[i].y,m[i+1].x,m[i+1].y);
  }
  for(int i=0;i<=anzahlMassen; i++){
    m[i].display();
  }
}

void mousePressed(){
  
   mausPos = new Vec2D(mouseX, mouseY);
   // Kraftfeld an mausPos mit Stärke 0.9 und Wirkweite 900
  mouseAttractor = new AttractionBehavior2D(mausPos, 900, 2);
  physics.addBehavior(mouseAttractor);
}

void mouseDragged() {
  // Kraftfeld Position updaten
  mausPos.set(mouseX, mouseY);
}

void mouseReleased() {
   // Kraftfeld entfernen
  physics.removeBehavior(mouseAttractor);
}


void keyPressed(){
  if(key=='s'){
   saveFrame("PendelSpur.jpg");
  }
}